vexpower_panelText_textfield = ""
vexpower_panelText_status = " "
vexpower_panelText_editmode = false
vexpower_panelText_editmodeGen = false

function vexpower.panel_text()
	if vexpower_panelText_textfield == "" then
		vexpower_panelText_textfield = vexpower_panelText_getFirstTextfield()
	end
	local tagvalues = {
		["PowerCurrent"] = "PowerCurrent",
		["PowerCurrentShort"] = "PowerCurrentShort",
		["PowerCurrentSmart"] = "PowerCurrentSmart",
		["PowerMax"] = "PowerMax",
		["PowerMaxShort"] = "PowerMaxShort",
		["PowerMaxSmart"] = "PowerMaxSmart",
		["PowerMissing"] = "PowerMissing",
		["PowerMissingShort"] = "PowerMissingShort",
		["PowerMissingSmart"] = "PowerMissingSmart",
		["PowerPerc"] = "PowerPerc",
		["PowerPercSmart"] = "PowerPercSmart",
		["BuffDurationTotal"] = "BuffDurationTotal",
		["BuffDurationLeft"] = "BuffDurationLeft",
		["CPsCurrent"] = "CPsCurrent",
		["CPsMax"] = "CPsMax",
		["CPsMissing"] = "CPsMissing",
		["PowerAltCurrent"] = "PowerAltCurrent",
		["PowerAltMax"] = "PowerAltMax",
		}

	return {
		type = "group",
		order= 3,
		args = {
			grpinfo = {
				name = "Tags to parse information in the text",
				order=1, type ="group", dialogInline = true,
				args = {
					energy1 = {name = "Current Power:\n|CFFFF7D0A[PowerCurrent]|r: Shows '19218' (current power)\n|CFFFF7D0A[PowerAltCurrent]|r: Shows '19218' (current alternative power)\n|CFFFF7D0A[PowerCurrentShort]|r: Shows '19' instead of '19218' (current power)\n|CFFFF7D0A[PowerCurrentSmart]|r: Shows '19.2' instead of '19218' (current power)", type="description", fontSize="medium", order=2},
					energy2 = {name = "Maximum Power:\n|CFFFF7D0A[PowerMax]|r: Shows '19218' (maximum power)\n|CFFFF7D0A[PowerAltMax]|r: Shows '19218' (maximum alternative power)\n|CFFFF7D0A[PowerMaxShort]|r: Shows '19' instead of '19218' (maximum power)\n|CFFFF7D0A[PowerMaxSmart]|r: Shows '19.2' instead of '19218' (maximum power)", type="description", fontSize="medium", order=3},
					energy3 = {name = "Missing Power:\n|CFFFF7D0A[PowerMissing]|r: Shows '19218' (missing power)\n|CFFFF7D0A[PowerMissingShort]|r: Shows '19' instead of '19218' (missing power)\n|CFFFF7D0A[PowerMissingSmart]|r: Shows '19.2' instead of '19218' (missing power)", type="description", fontSize="medium", order=4},
					energy4 = {name = "Percentage Power:\n|CFFFF7D0A[PowerPerc]|r: Shows '18' for 18.3%\n|CFFFF7D0A[PowerPercSmart]|r: Shows '18.3' for 18.3%", type="description", fontSize="medium", order=5},
					cps1 = {name = "ComboPoints:", type="description", fontSize="medium", order=21},
					cps2 = {name = "|CFFFF7D0A[CPsCurrent]|r: Shows your current ComboPoints/HolyPower/etc\n|CFFFF7D0A[CPsMax]|r: Shows your maximum ComboPoints/HolyPower/etc\n|CFFFF7D0A[CPsMissing]|r: Shows your missing ComboPoints/HolyPower/etc", type="description", fontSize="medium", order=22},
					buffs1 = {name = "Buffs (only when buffs are tracked as ComboPoints):", type="description", fontSize="medium", order=31},
					buffs2 = {name = "|CFFFF7D0A[BuffDurationLeft]|r: Shows the time left\n|CFFFF7D0A[BuffDurationTotal]|r: Shows the total duration", type="description", fontSize="medium", order=32},
					}
				},
			space1 = {name ="\n", type = "description", order=2},
			editmode = {
				name = "Textfield Editmode",
				order=3, type ="group", dialogInline = true,
				args = {
					info = {name ="During the Textfield Editmode, all Textfields get a colored background and are moveable. The editmode is only temporal and will be deactived not later than during the next ui reload", type = "description", order=2},
					allow = {
						name = "Activate",
						order=1, type = "toggle", width="full",
						set = function(self,val) vexpower_panelText_editmode = val vexpower_panelText_testmode() end,
						get = function() return vexpower_panelText_editmode end,
						},
					},
				},
			space2 = {name ="\n", type = "description", order=4},
			edit = {
				name = "Textfield Config",
				order=5, type ="group", dialogInline = true,
				args = {
					textfield = {
						name = "Textfield",
						order=5, type ="group", dialogInline = true,
						args = {
							profile = {
								name = "Textfield",
								order=1, type = "select", style = "dropdown",
								values = vexpower_panelText_getTextList(),
								set = function(self,val) vexpower_panelText_textfield = val vexpower_initialize(true) end,
								get = function() return vexpower_panelText_textfield end,
								},
							new = {
								name = "new",
								order=2, type = "execute", width="half",
								func = function(info,val) vexpower_panelText_New() vexpower_initialize(true) end,
								},
							clone = {
								name = "clone",
								order=3, type = "execute", width="half",
								func = function(info,val) vexpower_panelText_Clone() vexpower_initialize(true) end,
								},
							delete = {
								name = "delete",
								order=4, type = "execute", width="half",
								func = function(info,val) vexpower_panelText_Delete() vexpower_initialize(true) end,
								confirm = true,
								confirmText = "Are you sure you want to delete the textfield?"
								},
							status = {name = vexpower_panelText_status.."\n", type = "description", order=10},
							},
						},
					content = {
						name = "Content",
						order=11, type ="group", dialogInline = true,
						args = {
							framelefttextcontent = {
								name = "Text",
								desc = "Text that is shown left",
								order=10, type = "input", multiline = false,
								width = "double",
								disabled = vexpower_panelText_getDisabled(),
								set = function(info,val) vexpower_panelText_setDataDirect("text", val) vexpower_initialize(true) end,
								get = function() return vexpower_panelText_getDataDirect("text") end
								},
							frameleftinserttag = {
								name = "Insert Tag",
								order=12, type = "select", style = "dropdown",
								values = tagvalues,
								disabled = vexpower_panelText_getDisabled(),
								set = function(self,val) vexpower_panel_TagInsert("left", val) vexpower_initialize(true) end,
								get = function() return "" end,
								},
							},
						},
					config = {
						name = "Text config",
						order=21, type ="group", dialogInline = true,
						args = {
							font = {
								name = "Font",
								order=1, type = "select",
								dialogControl = "LSM30_Font",
								disabled = vexpower_panelText_getDisabled(),
								values = vexpower.LSM:HashTable("font"),
								set = function(self,val) vexpower_panelText_setDataDirect("font", val) vexpower_initialize(true) end,
								get = function() return vexpower_panelText_getDataDirect("font") end,
								},
							size = {
								name = "Size",
								order=2, type = "range",
								step = 1, min = 6, max = 20,
								disabled = vexpower_panelText_getDisabled(),
								set = function(info,val) vexpower_panelText_setDataDirect("size", val) vexpower_initialize(true) vexpower_panelText_testmode() end,
								get = function() return vexpower_panelText_getDataDirect("size") end,
								},
							space = {name = " ", type="description", order=10},
							align = {
								name = "Text align",
								order=20, type = "select", style = "dropdown",
								desc = "Sets the text align",
								disabled = vexpower_panelText_getDisabled(),
								values = {["LEFT"]="Left", ["CENTER"]="Center", ["RIGHT"]="Right"},
								set = function(self,val) vexpower_panelText_setDataDirect("align", val) vexpower_initialize(true) end,
								get = function() return vexpower_panelText_getDataDirect("align") end,
								},
							effect = {
								name = "effect",
								order=21, type = "select", style = "dropdown",
								values = {["MONOCHROME"]="Monochrome",
											["OUTLINE"]="Outline",
											[""]="None",
											["THICKOUTLINE"]="Thickoutline"},
								disabled = vexpower_panelText_getDisabled(),
								set = function(self,val) vexpower_panelText_setDataDirect("effect", val) vexpower_initialize(true) end,
								get = function() return vexpower_panelText_getDataDirect("effect") end,
								},
							color = {
								name = "color",
								order=30, type = "color", hasAlpha=true, width="double",
								desc = "Sets the text color",
								disabled = vexpower_panelText_getDisabled(),
								set = function(info,r,g,b,a)
									vexpower_panelText_setDataColor("r", r)
									vexpower_panelText_setDataColor("g", g)
									vexpower_panelText_setDataColor("b", b)
									vexpower_panelText_setDataColor("a", a)
									vexpower_initialize(true) end,
								get = function() return
									vexpower_panelText_getDataColor("r"),
									vexpower_panelText_getDataColor("g"),
									vexpower_panelText_getDataColor("b"),
									vexpower_panelText_getDataColor("a") end,
								},
							},
						},
					size = {
						name = "Size",
						order=31, type ="group", dialogInline = true,
						args = {
							width = {
								name = "Width",
								order=20, type = "range",
								step = 1, min = 1, max = 400,
								disabled = vexpower_panelText_getDisabled(),
								set = function(info,val) vexpower_panelText_setDataDirect("width", val) vexpower_initialize(true) vexpower_panelText_testmode() end,
								get = function() return vexpower_panelText_getDataDirect("width") end
								},
							},
						},
					position = {
						name = "Position",
						order=41, type ="group", dialogInline = true,
						args = {
							x = {
								name = "X Position",
								order=1, type = "range",
								step = 1, min = -300, max = 300,
								disabled = vexpower_panelText_getDisabled(),
								set = function(info,val) vexpower_panelText_setDataDirect("x", val) vexpower_initialize(true) vexpower_panelText_testmode() end,
								get = function() return vexpower_panelText_getDataDirect("x") end
								},
							y = {
								name = "Y Position",
								order=2, type = "range",
								step = 1, min = -300, max = 300,
								disabled = vexpower_panelText_getDisabled(),
								set = function(info,val) vexpower_panelText_setDataDirect("y", val) vexpower_initialize(true) vexpower_panelText_testmode() end,
								get = function() return vexpower_panelText_getDataDirect("y") end
								},
							space = {name = " ", type="description", order=10},
							anchor = {
								name = "Frame Textfield",
								order=20, type = "select", style = "dropdown",
								values = {
									["CENTER"]="Center",
									["BOTTOM"]="Bottom",
									["TOP"]="Top",
									["LEFT"]="Left",
									["RIGHT"]="Right",
									["BOTTOMLEFT"]="Bottomleft",
									["BOTTOMRIGHT"]="Bottomright",
									["TOPLEFT"]="Topleft",
									["TOPRIGHT"]="Topright"},
								disabled = vexpower_panelText_getDisabled(),
								set = function(self,val) vexpower_panelText_setDataDirect("anchor", val) vexpower_initialize(true) vexpower_panelText_testmode() end,
								get = function() return vexpower_panelText_getDataDirect("anchor") end,
								},
							anchor2 = {
								name = "Frame Powerbar",
								order=21, type = "select", style = "dropdown",
								values = {
									["CENTER"]="Center",
									["BOTTOM"]="Bottom",
									["TOP"]="Top",
									["LEFT"]="Left",
									["RIGHT"]="Right",
									["BOTTOMLEFT"]="Bottomleft",
									["BOTTOMRIGHT"]="Bottomright",
									["TOPLEFT"]="Topleft",
									["TOPRIGHT"]="Topright"},
								disabled = vexpower_panelText_getDisabled(),
								set = function(self,val) vexpower_panelText_setDataDirect("anchor2", val) vexpower_initialize(true) vexpower_panelText_testmode() end,
								get = function() return vexpower_panelText_getDataDirect("anchor2") end,
								},
							},
						},
					--space6 = {name = " ", type="description", order=50},
					grpshadow = {
						name = "Shadow Effect",
						order=51, type ="group", dialogInline = true,
						args = {
							allow = {
								name = "Activate shadow effect",
								order=1, type = "toggle", width="full",
								desc = "",
								disabled = vexpower_panelText_getDisabled(),
								set = function(self,val) vexpower_panelText_getDataShadow(false, "allow", val) vexpower_initialize(true) end,
								get = function() return vexpower_panelText_getDataShadow(false, "allow") end,
								},
							color = {
								name = "color",
								disabled = not(vexpower_panelText_getDataShadow(false, "allow")) or vexpower_panelText_getDisabled(),
								order=2, type = "color", hasAlpha=true, width="double",
								set = function(info,r,g,b,a)
									vexpower_panelText_setDataShadow("color", "r", r)
									vexpower_panelText_setDataShadow("color", "g", g)
									vexpower_panelText_setDataShadow("color", "b", b)
									vexpower_panelText_setDataShadow("color", "a", a)
									vexpower_initialize(true) end,
								get = function() return
									vexpower_panelText_getDataShadow("color", "r"),
									vexpower_panelText_getDataShadow("color", "g"),
									vexpower_panelText_getDataShadow("color", "b"),
									vexpower_panelText_getDataShadow("color", "a") end,
								},
							opacity = {
								name = "Opacity %",
								order=3, type = "range",
								step = 5, min = 0, max = 100,
								disabled = not(vexpower_panelText_getDataShadow(false, "allow")) or vexpower_panelText_getDisabled(),
								set = function(info,val) vexpower_panelText_setDataShadow("color", "a", val/100) vexpower_initialize(true) end,
								get = function() return vexpower_panelText_getDataShadow("color", "a") end
								},
							x = {
								name = "X Position",
								order=4, type = "range",
								step = 1, min = -50, max = 50,
								disabled = not(vexpower_panelText_getDataShadow(false, "allow")) or vexpower_panelText_getDisabled(),
								set = function(info,val) vexpower_panelText_getDataShadow("offset", "x", val) vexpower_initialize(true) end,
								get = function() return vexpower_panelText_getDataShadow("offset", "x") end
								},
							y = {
								name = "Y Position",
								order=5, type = "range",
								step = 1, min = -50, max = 50,
								disabled = not(vexpower_panelText_getDataShadow(false, "allow")) or vexpower_panelText_getDisabled(),
								set = function(info,val) vexpower_panelText_getDataShadow("offset", "y", val) vexpower_initialize(true) end,
								get = function() return vexpower_panelText_getDataShadow("offset", "y") end
								},
							},
						},
					}
				}
			}
		}
end

function vexpower_panelText_New()
	local newname = vexpower_panelText_getNewName()
	vexpower_parameters["frame"]["energy"]["text"][newname] = vexpower_CopyTable(vexpower_default_textfield)
	vexpower_panelText_textfield = newname
	vexpower_panelText_status = "New textfield '"..newname.."' created successfully"
	vexpower_panelText_testmode()
end

function vexpower_panelText_Clone()
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		local newname = vexpower_panelText_getNewName()
		vexpower_parameters["frame"]["energy"]["text"][newname] = vexpower_CopyTable(vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield])
		vexpower_panelText_status = "New textfield '"..newname.."' created successfully (Clone of "..vexpower_panelText_textfield..")"
		vexpower_panelText_textfield = newname
		vexpower_panelText_testmode()
	else
		vexpower_panelText_status = "ERROR: Couldn't clone textfield. Textfield '"..vexpower_panelText_textfield.."' doesn't exist"
	end
end

function vexpower_panelText_Delete()
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] = nil
		vexpower_energytext[vexpower_panelText_textfield]:Hide()
		vexpower_energytext[vexpower_panelText_textfield] = nil
		vexpower_panelText_status = "Textfield '"..vexpower_panelText_textfield.."' deleted successfully"
		vexpower_panelText_textfield = vexpower_panelText_getFirstTextfield()
		vexpower_panelText_testmode()
	else
		vexpower_panelText_status = "ERROR: Couldn't delete textfield. Textfield '"..vexpower_panelText_textfield.."' doesn't exist"
	end
end

function vexpower_panelText_getFirstTextfield()
	local number = 1
	local found = false
	local exist = false
	
	for key in pairs(vexpower_parameters["frame"]["energy"]["text"]) do
		if vexpower_parameters["frame"]["energy"]["text"][key] ~= nil then
			exist = true
		end
	end
	
	if exist then
		while not(found) do
			local name = tostring(number)
			if vexpower_parameters["frame"]["energy"]["text"][name] ~= nil then
				found = true
			else
				number = number + 1
			end
		end
		return tostring(number)
	else
		return ""
	end
end

function vexpower_panelText_getNewName()
	local number = 1
	local found = false
	while not(found) do
		local name = tostring(number)
		if vexpower_parameters["frame"]["energy"]["text"][name] == nil then
			found = true
		else
			number = number + 1
		end
	end
	return tostring(number)
end

function vexpower_panelText_getDisabled()
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		return false
	else
		return true
	end
end

function vexpower_panelText_setDataDirect(data, key)
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield][data] = key
	end
end

function vexpower_panelText_getDataDirect(data)
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		return vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield][data]
	end
end

function vexpower_panelText_getDataColor(data)
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		return vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["color"][data]
	end
end

function vexpower_panelText_setDataColor(data, key)
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["color"][data] = key
	end
end

function vexpower_panelText_getDataShadow(folder, data)
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		if folder == false then
			return vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["shadow"][data]
		else
			if folder == "color" and data == "a" then
				return vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["shadow"][folder][data]*100
			else
				return vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["shadow"][folder][data]
			end
		end
	end
end

function vexpower_panelText_setDataShadow(folder, data, key)
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		if folder == false then
			vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["shadow"][data] = key
		else
			vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["shadow"][folder][data] = key
		end
	end
end

function vexpower_panelText_getTextList()
	local returnvalue = {}
	local timer = 0
	for key in pairs(vexpower_parameters["frame"]["energy"]["text"]) do
		if key ~= "profilelist" then
			returnvalue[key]=key
			timer = timer + 1
		end
	end
	
	if timer == 0 then
		returnvalue[""] = "No textfields created"
	end
	
	return returnvalue
end

function vexpower_panel_TagInsert(text, tag)
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["text"] = vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["text"].."["..tag.."] "
	end
end

function vexpower_panelText_testmode()
	if vexpower_panelText_editmodeGen then
		vexpower_panelText_testmodeNuke()
	end
	
	if vexpower_panelText_editmode then
		vexpower_panelText_testmodeGenerate()
	end
end

function vexpower_panelText_testmodeGenerate()
	-- for key in pairs(vexpower_energytext) do
		-- if vexpower_energytext[key] ~= nil then
			-- vexpower_energytext[key]:SetMovable(true)
		-- end
	-- end
	for key in pairs(vexpower_energytext) do
		if vexpower_parameters["frame"]["energy"]["text"][key] ~= nil and vexpower_energytext[key] ~= nil then
			if vexpower_energytext_TestFrames == nil then
				vexpower_energytext_TestFrames = {}
			end
			vexpower_energytext_TestFrames[key] = CreateFrame("Frame", nil, vexpower_energybarbg)
			vexpower_energytext_TestFrames[key]:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false, edgeFile="Interface\\Buttons\\WHITE8X8", edgeSize=1})
			vexpower_energytext_TestFrames[key]:SetBackdropColor(1, 1, 1, 1)
			vexpower_energytext_TestFrames[key]:SetBackdropBorderColor(1,0,0,1)
			vexpower_energytext_TestFrames[key]:SetWidth(vexpower_energytext[key]:GetWidth())
			vexpower_energytext_TestFrames[key]:SetHeight(vexpower_energytext[key]:GetHeight())
			vexpower_energytext_TestFrames[key]:ClearAllPoints()
			vexpower_energytext_TestFrames[key]:SetPoint(
				vexpower_parameters["frame"]["energy"]["text"][key]["anchor"],
				"vexpower_energyTextbar",
				vexpower_parameters["frame"]["energy"]["text"][key]["anchor2"],
				vexpower_parameters["frame"]["energy"]["text"][key]["x"],
				vexpower_parameters["frame"]["energy"]["text"][key]["y"])
			
			vexpower_energytext_TestFrames[key]:RegisterForDrag("LeftButton")
			vexpower_energytext_TestFrames[key]:SetScript("OnDragStart", function ()
				vexpower_energytext_TestFrames[key]:StartMoving()
				end)
			vexpower_energytext_TestFrames[key]:SetScript("OnDragStop", function (self)
				self:StopMovingOrSizing()
				local x1, y1 = self:GetLeft(), self:GetTop()
				local x2, y2 = self:GetParent():GetLeft(), self:GetParent():GetTop()
				self:ClearAllPoints()
				self:SetPoint("TOPLEFT", self:GetParent(), "TOPLEFT", x1 - x2, y1 - y2)
				vexpower_saveTextfieldPos(key)
				vexpower_setFontStrings()
				end)
			vexpower_energytext_TestFrames[key]:EnableMouse(true)
			vexpower_energytext_TestFrames[key]:SetMovable(true)
			vexpower_panelText_editmodeGen = true
		end
	end
end

function vexpower_panelText_testmodeNuke()
	if vexpower_energytext_TestFrames~= nil then
		for key in pairs(vexpower_energytext_TestFrames) do
			if vexpower_energytext_TestFrames[key]~= nil then
				vexpower_energytext_TestFrames[key]:Hide()
				vexpower_energytext_TestFrames[key] = nil
			end
		end
	end
	vexpower_panelText_editmodeGen = false
end

function vexpower_saveTextfieldPos(key)
	vexpower_parameters["frame"]["energy"]["text"][key]["anchor"] =  select(1, vexpower_energytext_TestFrames[key]:GetPoint())
	vexpower_parameters["frame"]["energy"]["text"][key]["anchor2"] =  select(3, vexpower_energytext_TestFrames[key]:GetPoint())
	vexpower_parameters["frame"]["energy"]["text"][key]["x"] =  select(4, vexpower_energytext_TestFrames[key]:GetPoint())
	vexpower_parameters["frame"]["energy"]["text"][key]["y"] =  select(5, vexpower_energytext_TestFrames[key]:GetPoint())
end
















